package livelock;

public class Consumatore implements Runnable {
	private Prodotto pr;
	private boolean endLoop;
	
	public Consumatore(Prodotto pr) {
		this.pr = pr;
		this.endLoop = false;
	}
	
	@Override
	public void run() {
		try {
			while(this.endLoop == false) {
				pr.consuma();
				System.out.println("Consumo");
				Thread.sleep(50);
			}
			System.out.println("Fine Consumatore");
		} catch(InterruptedException ex) {
			ex.printStackTrace();
			System.out.println(ex.getMessage());
		} 
	}
	
	/**
	 * Per terminare l'esecuzione di un thread
	 */
	public void stop() {
		this.endLoop = true;
	}
	
}
