package livelock;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.locks.ReentrantLock;

public class Main {

	public static void main(String[] args) {
		try {
			ReentrantLock lock = new ReentrantLock();
			Prodotto obj = new Prodotto(lock);
			Consumatore cons = new Consumatore(obj);
			Consumatore cons2 = new Consumatore(obj);
			Produttore prod = new Produttore(obj);
			
		
			System.out.println("Inizio Concorrenza\n\n");
			
			//Uso l'API concorrente di java come alternativa ai thread
			ExecutorService es = Executors.newCachedThreadPool();
			//eseguo i vari thread
			es.execute(cons);
			es.execute(cons2);
			es.execute(prod);
			
			//faccio lavorare per un secondo
			Thread.sleep(1000); 
			
			//fermo tutti i thread
			prod.stop();
			cons.stop();
			cons2.stop();
			
			//non accetto pi nuovi task
			es.shutdown(); 
			//aspetto la terminazione dei task nell'ExecutorService
			while(es.awaitTermination(100, TimeUnit.MILLISECONDS) == false) {
				System.out.println("Aspetto terminazione thread");
				obj.liveLockSolution(); //risolvo il livelock
			}
			System.out.println("Fine Concorrenza");

		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch(Exception e) {
			e.printStackTrace();
		}

	}

}
